package com.tzld.piaoquan.content.understanding.service;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.data.Record;
import com.aliyun.oss.model.ObjectMetadata;
import com.tzld.commons.aliyun.oss.AliyunOssManager;
import com.tzld.piaoquan.content.understanding.BaseTest;
import com.tzld.piaoquan.content.understanding.dao.mapper.CuPromptMapper;
import com.tzld.piaoquan.content.understanding.dao.mapper.WxVideoMapper;
import com.tzld.piaoquan.content.understanding.model.param.ActionParam;
import com.tzld.piaoquan.content.understanding.model.po.CuPrompt;
import com.tzld.piaoquan.content.understanding.model.po.WxVideo;
import com.tzld.piaoquan.content.understanding.service.impl.ContentServiceImpl;
import com.tzld.piaoquan.content.understanding.service.impl.GeminiGenerateContentAction;
import org.assertj.core.util.Lists;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.concurrent.ThreadLocalRandom;
import java.util.concurrent.TimeUnit;

public class ContentServiceTest extends BaseTest {

    private static final Logger LOGGER = LoggerFactory.getLogger(ContentServiceTest.class);

    @Autowired
    private AliyunOssManager aliyunOssManager;

    @Autowired
    private ODPSManager odpsManager;

    @Autowired
    private WxVideoMapper wxVideoMapper;

    @Autowired
    private CuPromptMapper cuPromptMapper;

    @Autowired
    private Action geminiGenerateContentAction;

    @Test
    public void ossTest() {
        String origin = "longvideo/crawler_local/video/prod/20240523/adab3bae11b0b168d20ddf0e2a9679a81721808114115297282";
        String transcode = "longvideo/transcode/crawler_local/video/prod/20231108/adab3bae11b0b168d20ddf0e2a9679a81721808114115297282.mp4";
        String multi = "output/longvideo/multitranscode/crawler_local/video/prod/20240523/adab3bae11b0b168d20ddf0e2a9679a8172180811411529728220240524131000797723823-1LD.mp4";
//        ObjectMetadata objectMetadata1 = aliyunOssManager.getObjectMetadata(ContentServiceImpl.TRANSCODE_BUCKET, origin);
//        try {
//            objectMetadata1.isRestoreCompleted();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        没有获取到会抛NPE
//        System.out.println(objectMetadata1.isRestoreCompleted());
        ObjectMetadata objectMetadata2 = aliyunOssManager.getObjectMetadata(ContentServiceImpl.TRANSCODE_BUCKET, transcode);
        try {
            System.out.println(objectMetadata2.isRestoreCompleted());
        } catch (Exception e) {
            e.printStackTrace();
        }

        aliyunOssManager.restoreObject(ContentServiceImpl.TRANSCODE_BUCKET, transcode, 1);

        objectMetadata2 = aliyunOssManager.getObjectMetadata(ContentServiceImpl.TRANSCODE_BUCKET, transcode);
        System.out.println(objectMetadata2.isRestoreCompleted());


//        ObjectMetadata objectMetadata3 = aliyunOssManager.getObjectMetadata("art-visionular-out", multi);
//        System.out.println(objectMetadata3.isRestoreCompleted());
    }

    @Test
    void generateContentTest() {
        CuPrompt cuPrompt = cuPromptMapper.selectByPrimaryKey(3L);
        String prompt = cuPrompt.getPrompt();
        Map<String, String> map = new HashMap<>();
//        map.put("20948644", "longvideo/transcode/crawler_local/video/prod/20240524/17af0316a47ea1492b035a06752c7c436395417487.mp4");
//        map.put("23057638", "longvideo/transcode/video/vpc/20240731/714823146bNfUv1N4jDSiwuLbD.mp4");
//        map.put("26584290", "jq_oss/video/2024091015350471424.mp4");
//        map.put("53159570", "longvideo/transcode/video/vpc/20250414/66055634r2nxtq7fNh7CvY0l6.mp4");
//        map.put("53278955", "longvideo/transcode/video/vpc/20250521/299ac36ebd531ac3123358b26d688653.mp4");
//        map.put("53569056", "longvideo/transcode/video/vpc/20250525/7d9279f746ae8d7124c2b170f612f347.mp4");
//        map.put("53898417", "longvideo/transcode/crawler_local/video/prod/20250601/ed909991518e12bafecdb0f290d975e954090447.mp4");
//        map.put("53960514", "longvideo/transcode/crawler_local/video/prod/20250602/4bc4d8ff2e2ddcdde83a9ea15329a40a76650991.mp4");
//        map.put("54073329", "longvideo/transcode/video/vpc/20250605/fbdccc5dc06960fba3b1366ed8aff6ac.mp4");
//        map.put("54170592", "longvideo/transcode/video/vpc/20250606/0c1c491f541f706a44ef71c78589c62c.mp4");
//        map.put("54176577", "longvideo/transcode/video/vpc/20250606/50322238EjC1iL9CidJLy9mIfI.mp4");
//        map.put("54190543", "longvideo/transcode/video/vpc/20250607/57463792kggsvrvXZAHvApuKLY.mp4");
//        map.put("54192721", "longvideo/transcode/video/vpc/20250520/ec3ab39bce50fe266e5e6d048594832f.mp4");
//        map.put("54253744", "longvideo/transcode/video/vpc/20250605/50322238LAHlFtTfmaZFWltcXu.mp4");
//        map.put("54260957", "longvideo/transcode/crawler_local/video/prod/20250526/a76b38009b35ec47d5281ce040ef2f40683476660000012753e751df.mp4");
//        map.put("54300907", "longvideo/transcode/video/vpc/20250609/202ffb51f764d0505a3fd0554e0fd193.mp4");
//        map.put("54305805","longvideo/transcode/crawler_local/video/prod/20250609/80edf08d06eda65ec264949de3392cff76809583.mp4");
//        map.put("54310659", "carry/video/0413f529-5893-44fb-bcb9-21c7d75b7881.mp4");
//        map.put("54310902", "longvideo/transcode/crawler_local/video/prod/20250607/dd4fc2008997315fa25ff61963fa011368427369000001270e4286a9.mp4");
//        map.put("54310964", "longvideo/transcode/video/vpc/20250515/574637922GmjFokNnJ9lwi731y.mp4");
//        map.put("54332925", "longvideo/transcode/video/vpc/20250610/624c7e8226264557c381af613a6d2ca6.mp4");
//        map.put("54345952", "longvideo/transcode/crawler_local/video/prod/20250610/524ef90cd28fd73559649cd6951de09d76978191.mp4");
//        map.put("54369297", "longvideo/transcode/video/vpc/20250611/6a1b26005dbfc4140bd641a178f2b41c.mp4");
//        map.put("54377853", "longvideo/transcode/video/vpc/20240628/57463791mb2akNHXQPfhtXmevd.mp4");
//        map.put("54377890", "longvideo/transcode/crawler_local/video/prod/20250611/6ef7ae5f9d67cc4c7c83baf04a4fe79c76878810.mp4");
//        map.put("54378772", "longvideo/transcode/video/vpc/20250611/57463792Wu8t3qg95GZEX5sGXH.mp4");
//        map.put("54382144", "longvideo/transcode/video/vpc/20250611/57463791K4wh6N5Biqk7TTbz3S.mp4");
//        map.put("54382146", "longvideo/transcode/video/vpc/20250611/57463791K4wh6N5Biqk7TTbz3S.mp4");
//        map.put("54393254", "longvideo/transcode/video/vpc/20250517/71785633aDQVC9AB1pOlGcF0hk.mp4");
//        map.put("54393645", "longvideo/transcode/video/vpc/20250611/71510168oSLcgIrZNhJIwNPALM.mp4");
//        map.put("54418122", "longvideo/transcode/video/vpc/20250612/32f4b0037472a99174103d0214f6e2bc.mp4");
//        map.put("54432755", "longvideo/transcode/crawler_local/video/prod/20250612/cbf5155ff4e9416c0d8a25f50484111a125189.mp4");
//        map.put("54435431", "longvideo/transcode/video/vpc/20250612/aebbd3cfc2b16afe257a829fc172ee6a.mp4");
//        map.put("54459114", "longvideo/transcode/video/vpc/20250613/686a6aecce846cb80c1a620be57183c2.mp4");
//        map.put("54466622", "longvideo/transcode/video/vpc/20250613/660556338WXg8h8NBRimitcIK.mp4");
//        map.put("54480902", "longvideo/transcode/video/vpc/20250613/25911768jKW2tTAatCbYM29Gaf.mp4");
//        map.put("54503615", "longvideo/transcode/crawler_local/video/prod/20250614/1f7a19ebffcc14789f62e26756f3f9cb77013598.mp4");
//        map.put("54504464", "longvideo/transcode/video/vpc/20240613/57463860zLVTQmpmcb9ws0lChi.mp4");
//        map.put("54514675", "longvideo/transcode/video/vpc/20250601/c3e833bfc6b7b4d4d7fed573066bfc3f.mp4");
//        map.put("54514940", "longvideo/transcode/crawler_local/video/prod/20250614/404bc98774915bd5f6846a4505f29bc154164667.mp4");
        for (Map.Entry<String, String> entry : map.entrySet()) {
            try {
                String videoId = entry.getKey();
                String url = "http://rescdn.yishihui.com/" + entry.getValue();
                ActionParam actionParam = new ActionParam();
                actionParam.setType(2);
                actionParam.setInput(url);
                actionParam.setPrompt(prompt);
                String result = geminiGenerateContentAction.execute(actionParam);
                if (Objects.nonNull(result)) {
                    JSONObject jsonObject = JSONObject.parseObject(result);
                    JSONObject jsonObject1 = jsonObject.getJSONObject("五、音画细节");
                    String score = jsonObject1.getString("AI生成可能性评分");
//                    System.out.println("结果---" + videoId + "," + score);
                    LOGGER.info("结果---{} {}", videoId, score);
                }
                ThreadLocalRandom random = ThreadLocalRandom.current();
                TimeUnit.SECONDS.sleep(random.nextInt(120, 360));
            } catch (Exception e) {
                LOGGER.error("execute error {}", entry.getKey());
            }
        }
    }
}
